;---------------------------------------------------------------------------
;    MULTITECH MPF-1,   
;     RS-232.
; V. 16.07.2021 (,   )
;---------------------------------------------------------------------------
        ORG     0000H

        LD      B,00H        ; 0000 0600
L0002:
        DJNZ    L0002        ; 0002 10FE     256 

        LD      A,90H        ; 0004 3E90   0,  - , ,  -
        OUT     (03H),A      ; 0006 D303
;------ RST     08H          ; CFH, 10 - D7H, 18 - DFH, 20 - E7H
        LD      A,0C0H       ; 0008 3EC0  1100.0000b  6  
        OUT     (02H),A      ; 000A D302   ,  6 - NMI,  7 - 

        LD      SP,S1FAF     ; 000C 31AF1F   "" 
        LD      A,(M1FE5)    ; 000F 3AE51F
        CP      0A5H         ; 0012 FEA5   -  
        CALL    NZ,L03C1     ; 0014 C4C103 cold reset (holds not 0A5H).

        LD      HL,1000H     ; 0017 210010 warm Reset (holds 0A5H)
        CALL    RAMCH        ; 001A CDF605   0FFFH 
        JR      Z,L0021      ; 001D 2802

        LD      H,18H        ; 001F 2618
L0021:
        LD      (M1FDC),HL   ; 0021 22DC1F
        LD      H,00H        ; 0024 2600
        JR      L0032        ; 0026 180A

;------ RST     28H          ;=0EFH
        EX      (SP),HL      ; 0028 E3
        DEC     HL           ; 0029 2B
        EX      (SP),HL      ; 002A E3
        LD      (M1FE8),HL   ; 002B 22E81F
        JR      L003E        ; 002E 180E  ---    6  NMI

;------ RST     30H          ;=0F7H
        JR      L0066        ; 0030 1834  ---   NMI
L0032:
        LD      (M1FD2),HL   ; 0032 22D21F
        JR      L0054        ; 0035 181D
;------
        LD      (HL),C       ; 0037 71

;------ RST     38H
        PUSH    HL           ; 0038 E5
        LD      HL,(M1FEE)   ; 0039 2AEE1F ---   NMI
        EX      (SP),HL      ; 003C E3           M1FEE
        RET                  ; 003D C9 ---  NMI  

L003E:
        LD      (M1FE7),A    ; 003E 32E71F
        LD      HL,(M1FE0)   ; 0041 2AE01F
        LD      A,(M1FE2)    ; 0044 3AE21F
        LD      (HL),A       ; 0047 77

        LD      A,80H        ; 0048 3E80   1000.0000b   6 - NMI
        OUT     (02H),A      ; 004A D302   

        LD      A,(M1FE7)    ; 004C 3AE71F   NMI
        LD      HL,(M1FE8)   ; 004F 2AE81F  4 fetch-a
        NOP                  ; 0052 00
        RET                  ; 0053 C9

L0054:
        LD      HL,M1F9F     ; 0054 219F1F
        LD      (M1FD0),HL   ; 0057 22D01F
        XOR     A            ; 005A AF
        LD      (M1FE6),A    ; 005B 32E61F
        LD      IX,M079F     ; 005E DD219F07 *** uPF--1
        JP      L00D0        ; 0062 C3D000
        RST     38H          ; 0065 FF

; by default, a monitor interrupt routine
L0066:
        LD      (M1FE7),A    ; 0066 32E71F

        LD      A,90H        ; 0069 3E90     
        OUT     (03H),A      ; 006B D303
        LD      A,0C0H       ; 006D 3EC0 1100.0000b    6 - NMI -
        OUT     (02H),A      ; 006F D302 !

        LD      A,(M1FE7)    ; 0071 3AE71F
        LD      (M1FE8),HL   ; 0074 22E81F
        POP     HL           ; 0077 E1
        LD      (M1FDE),HL   ; 0078 22DE1F
        LD      (M1FDC),HL   ; 007B 22DC1F
        LD      HL,(M1FE8)   ; 007E 2AE81F
        LD      (M1FD0),SP   ; 0081 ED73D01F
        LD      SP,M1FD0     ; 0085 31D01F
        PUSH    IY           ; 0088 FDE5
        PUSH    IX           ; 008A DDE5
        EXX                  ; 008C D9
        PUSH    HL           ; 008D E5
        PUSH    DE           ; 008E D5
        PUSH    BC           ; 008F C5
        EXX                  ; 0090 D9
        EX      AF,AF'       ; 0091 08
        PUSH    AF           ; 0092 F5
        EX      AF,AF'       ; 0093 08
        PUSH    HL           ; 0094 E5
        PUSH    DE           ; 0095 D5
        PUSH    BC           ; 0096 C5
        PUSH    AF           ; 0097 F5
        LD      A,I          ; 0098 ED57
        LD      (M1FD3),A    ; 009A 32D31F
        LD      A,00H        ; 009D 3E00
        JP      PO,L00A4     ; 009F E2A400
        LD      A,01H        ; 00A2 3E01
L00A4:
        LD      (M1FD2),A    ; 00A4 32D21F
        LD      SP,S1FAF     ; 00A7 31AF1F
        LD      HL,(M1FD0)   ; 00AA 2AD01F
        LD      IX,M07B5     ; 00AD DD21B507 ***
        DEC     HL           ; 00B1 2B
        CALL    RAMCH        ; 00B2 CDF605
        JR      NZ,L00D0     ; 00B5 2019
        DEC     HL           ; 00B7 2B
        CALL    RAMCH        ; 00B8 CDF605
        JR      NZ,L00D0     ; 00BB 2013
        LD      IX,M07AF     ; 00BD DD21AF07 ***
        NOP                  ; 00C1 00
        NOP                  ; 00C2 00
        LD      DE,0E062H    ; 00C3 1162E0
        ADD     HL,DE        ; 00C6 19
        JR      C,L00D0      ; 00C7 3807

        LD      IX,M1FB6     ; 00C9 DD21B61F
        SCF                  ; 00CD 37
        JR      L00D4        ; 00CE 1804
L00D0:
        XOR     A            ; 00D0 AF
        LD      (M1FE4),A    ; 00D1 32E41F
L00D4:
        LD      A,(M1FE2)    ; 00D4 3AE21F
        LD      HL,(M1FE0)   ; 00D7 2AE01F
        LD      (HL),A       ; 00DA 77
        CALL    C,L040B      ; 00DB DC0B04
L00DE:
        LD      SP,S1FAF     ; 00DE 31AF1F
        CALL    SCANP        ; 00E1 CDFE05       ,
        CALL    L06CB        ; 00E4 CDCB06    . ,   55H
        JR      L00DE        ; 00E7 18F5    
L00E9:
        CP      10H          ; 00E9 FE10
        JR      C,L0111      ; 00EB 3824
        LD      HL,M1FE6     ; 00ED 21E61F
        SET     0,(HL)       ; 00F0 CBC6
        SUB     10H          ; 00F2 D610
        CP      08H          ; 00F4 FE08
        LD      HL,M0737     ; 00F6 213707 ***
        JP      C,L03B0      ; 00F9 DAB003

        LD      IX,M1FB6     ; 00FC DD21B61F
        SUB     08H          ; 0100 D608
        LD      HL,M1FE4     ; 0102 21E41F
        LD      (HL),A       ; 0105 77
        LD      HL,M1FE3     ; 0106 21E31F
        LD      (HL),00H     ; 0109 3600
        LD      HL,M0741     ; 010B 214107 ***
        JP      L03B0        ; 010E C3B003
L0111:
        LD      C,A          ; 0111 4F
        LD      HL,M074B     ; 0112 214B07 ***
L0115:
        LD      A,(M1FE4)    ; 0115 3AE41F
        JP      L03B0        ; 0118 C3B003
        LD      HL,M0757     ; 011B 215707 ***
        JR      L0115        ; 011E 18F5

        LD      HL,M0763     ; 0120 216307 ***
        JR      L0115        ; 0123 18F0
        LD      HL,M076F     ; 0125 216F07 ***
        JR      L0115        ; 0128 18EB

        CALL    L03E5        ; 012A CDE503
        JP      NZ,L03BB     ; 012D C2BB03
        LD      A,80H        ; 0130 3E80
        JP      L02A3        ; 0132 C3A302

        CALL    L03E5        ; 0135 CDE503
        JR      NZ,L013E     ; 0138 2004
        CALL    L040B        ; 013A CD0B04
        RET                  ; 013D C9

L013E:
        CP      08H          ; 013E FE08
        JP      C,L03BB      ; 0140 DABB03
        CALL    L0477        ; 0143 CD7704
        RET                  ; 0146 C9

        CALL    L03E5        ; 0147 CDE503
        JP      NZ,L03BB     ; 014A C2BB03

        LD      HL,(M1FDE)   ; 014D 2ADE1F
        CALL    RAMCH        ; 0150 CDF605
        JP      NZ,L03BB     ; 0153 C2BB03
        LD      (M1FE0),HL   ; 0156 22E01F
        CALL    L040B        ; 0159 CD0B04
        RET                  ; 015C C9

        CALL    L03E5        ; 015D CDE503
        JP      NZ,L03BB     ; 0160 C2BB03
        LD      HL,(M1FDE)   ; 0163 2ADE1F
        NOP                  ; 0166 00
        LD      (S1FAF),HL   ; 0167 22AF1F
        INC     HL           ; 016A 23
        LD      (M1FB3),HL   ; 016B 22B31F
        CALL    RAMCH        ; 016E CDF605
        JP      NZ,L03BB     ; 0171 C2BB03
        LD      DE,M1DFE     ; 0174 11FE1D
        LD      A,H          ; 0177 7C
        CP      1EH          ; 0178 FE1E
        JR      C,L0183      ; 017A 3807
        CP      20H          ; 017C FE20
        JP      C,L03BB      ; 017E DABB03
        LD      D,27H        ; 0181 1627
L0183:
        LD      (M1FB1),DE   ; 0183 ED53B11F
L0187:
        CALL    L02E4        ; 0187 CDE402
        XOR     A            ; 018A AF
        LD      (DE),A       ; 018B 12
        LD      HL,(M1FB3)   ; 018C 2AB31F
        LD      (M1FDE),HL   ; 018F 22DE1F
        CALL    L040B        ; 0192 CD0B04
        RET                  ; 0195 C9

        CALL    L03E5        ; 0196 CDE503
        JP      NZ,L03BB     ; 0199 C2BB03
        LD      HL,(M1FDE)   ; 019C 2ADE1F
        NOP                  ; 019F 00
        LD      (M1FB3),HL   ; 01A0 22B31F
        CALL    RAMCH        ; 01A3 CDF605
        JP      NZ,L03BB     ; 01A6 C2BB03
        LD      DE,M1E00     ; 01A9 11001E
        LD      A,H          ; 01AC 7C
        CP      1EH          ; 01AD FE1E
        JR      C,L01B8      ; 01AF 3807
        CP      20H          ; 01B1 FE20
        JP      C,L03BB      ; 01B3 DABB03
        LD      D,28H        ; 01B6 1628
L01B8:
        LD      (M1FB1),DE   ; 01B8 ED53B11F
        INC     HL           ; 01BC 23
        LD      (S1FAF),HL   ; 01BD 22AF1F
        JR      L0187        ; 01C0 18C5

        LD      HL,(M1FDC)   ; 01C2 2ADC1F
        LD      (M1FDE),HL   ; 01C5 22DE1F
        CALL    L040B        ; 01C8 CD0B04
        RET                  ; 01CB C9

        CALL    L03DE        ; 01CC CDDE03
        LD      (M1FDE),HL   ; 01CF 22DE1F
        CALL    L040B        ; 01D2 CD0B04
        RET                  ; 01D5 C9

        LD      IX,M07CA     ; 01D6 DD21CA07  ***
        CALL    L04C4        ; 01DA CDC404
        RET                  ; 01DD C9

        CALL    L0402        ; 01DE CD0204
        RET                  ; 01E1 C9

        LD      HL,(M1FDE)   ; 01E2 2ADE1F
        LD      (S1FAF),HL   ; 01E5 22AF1F
        CALL    L043A        ; 01E8 CD3A04
        RET                  ; 01EB C9

        JP      L03BB        ; 01EC C3BB03
        LD      HL,(M1FDE)   ; 01EF 2ADE1F
        CALL    RAMCH        ; 01F2 CDF605
        JP      NZ,L03BB     ; 01F5 C2BB03
        CALL    L03EE        ; 01F8 CDEE03
        LD      A,C          ; 01FB 79
        RLD                  ; 01FC ED6F
        CALL    L040B        ; 01FE CD0B04
        RET                  ; 0201 C9

        LD      HL,M1FDE     ; 0202 21DE1F
        CALL    L03FA        ; 0205 CDFA03
        LD      A,C          ; 0208 79
        RLD                  ; 0209 ED6F
        INC     HL           ; 020B 23
        RLD                  ; 020C ED6F
        CALL    L0402        ; 020E CD0204
        RET                  ; 0211 C9

        LD      A,C          ; 0212 79
        LD      IX,M1FB6     ; 0213 DD21B61F
        LD      HL,M1FE3     ; 0217 21E31F
        ADD     A,A          ; 021A 87
        LD      (HL),A       ; 021B 77
        CALL    L0473        ; 021C CD7304
        RET                  ; 021F C9

        CALL    L0455        ; 0220 CD5504
        CALL    L03FA        ; 0223 CDFA03
        LD      A,C          ; 0226 79
        RLD                  ; 0227 ED6F
        INC     HL           ; 0229 23
        RLD                  ; 022A ED6F
        CALL    L043A        ; 022C CD3A04
        RET                  ; 022F C9

        CALL    L04BB        ; 0230 CDBB04
        CALL    L03EE        ; 0233 CDEE03
        LD      A,C          ; 0236 79
        RLD                  ; 0237 ED6F
        CALL    L0477        ; 0239 CD7704
        RET                  ; 023C C9

        JP      L03BB        ; 023D C3BB03
        LD      HL,(M1FDE)   ; 0240 2ADE1F
        INC     HL           ; 0243 23
        LD      (M1FDE),HL   ; 0244 22DE1F
        CALL    L040B        ; 0247 CD0B04
        RET                  ; 024A C9

        LD      HL,M1FE3     ; 024B 21E31F
        INC     (HL)         ; 024E 34
        CALL    L045F        ; 024F CD5F04
        JR      NZ,L0258     ; 0252 2004
        DEC     (HL)         ; 0254 35
        JP      L03BB        ; 0255 C3BB03
L0258:
        CALL    L043A        ; 0258 CD3A04
        RET                  ; 025B C9

        LD      HL,M1FE3     ; 025C 21E31F
        INC     (HL)         ; 025F 34
        LD      A,1FH        ; 0260 3E1F
        CP      (HL)         ; 0262 BE
        JR      NC,L0267     ; 0263 3002
        LD      (HL),00H     ; 0265 3600
L0267:
        CALL    L0477        ; 0267 CD7704
        RET                  ; 026A C9
        JP      L03BB        ; 026B C3BB03
        LD      HL,(M1FDE)   ; 026E 2ADE1F
        DEC     HL           ; 0271 2B
        LD      (M1FDE),HL   ; 0272 22DE1F
        CALL    L040B        ; 0275 CD0B04
        RET                  ; 0278 C9

        LD      HL,M1FE3     ; 0279 21E31F
        DEC     (HL)         ; 027C 35
        CALL    L045F        ; 027D CD5F04
        JR      NZ,L0286     ; 0280 2004
        INC     (HL)         ; 0282 34
        JP      L03BB        ; 0283 C3BB03
L0286:
        CALL    L043A        ; 0286 CD3A04
        RET                  ; 0289 C9

        LD      HL,M1FE3     ; 028A 21E31F
        DEC     (HL)         ; 028D 35
        LD      A,1FH        ; 028E 3E1F
        CP      (HL)         ; 0290 BE
        JR      NC,L0295     ; 0291 3002
        LD      (HL),1FH     ; 0293 361F
L0295:
        CALL    L0477        ; 0295 CD7704
        RET                  ; 0298 C9

        JP      L03BB        ; 0299 C3BB03

        LD      HL,(M1FE0)   ; 029C 2AE01F
        LD      (HL),0EFH    ; 029F 36EF
        LD      A,0FFH       ; 02A1 3EFF
L02A3:
        LD      (M1FEA),A    ; 02A3 32EA1F
        LD      A,(M1FD2)    ; 02A6 3AD21F
        BIT     0,A          ; 02A9 CB47
        LD      HL,0C9FBH    ; 02AB 21FBC9  ???
        JR      NZ,L02B2     ; 02AE 2002
        LD      L,0F3H       ; 02B0 2EF3
L02B2:
        LD      (M1FEB),HL   ; 02B2 22EB1F
        LD      SP,M1FBC     ; 02B5 31BC1F
        POP     AF           ; 02B8 F1
        POP     BC           ; 02B9 C1
        POP     DE           ; 02BA D1
        POP     HL           ; 02BB E1
        EX      AF,AF'       ; 02BC 08
        POP     AF           ; 02BD F1
        EX      AF,AF'       ; 02BE 08
        EXX                  ; 02BF D9
        POP     BC           ; 02C0 C1
        POP     DE           ; 02C1 D1
        POP     HL           ; 02C2 E1
        EXX                  ; 02C3 D9
        POP     IX           ; 02C4 DDE1
        POP     IY           ; 02C6 FDE1
        LD      SP,(M1FD0)   ; 02C8 ED7BD01F
        LD      (M1FBD),A    ; 02CC 32BD1F
        LD      A,(M1FD3)    ; 02CF 3AD31F
        LD      I,A          ; 02D2 ED47
        PUSH    HL           ; 02D4 E5
        LD      HL,(M1FDE)   ; 02D5 2ADE1F
        EX      (SP),HL      ; 02D8 E3
        LD      A,(M1FEA)    ; 02D9 3AEA1F
        OUT     (02H),A      ; 02DC D302
        LD      A,(M1FBD)    ; 02DE 3ABD1F
        JP      M1FEB        ; 02E1 C3EB1F
L02E4:
        LD      HL,S1FAF     ; 02E4 21AF1F
        CALL    L053D        ; 02E7 CD3D05
        JR      C,ERROR      ; 02EA 3867
        LD      DE,(M1FB3)   ; 02EC ED5BB31F
        SBC     HL,DE        ; 02F0 ED52
        JR      NC,L0300     ; 02F2 300C
        EX      DE,HL        ; 02F4 EB
        ADD     HL,BC        ; 02F5 09
        DEC     HL           ; 02F6 2B
        EX      DE,HL        ; 02F7 EB
        LD      HL,(M1FB1)   ; 02F8 2AB11F
        LDDR                 ; 02FB EDB8
        INC     DE           ; 02FD 13
        JR      L031C        ; 02FE 181C
L0300:
        ADD     HL,DE        ; 0300 19
        LDIR                 ; 0301 EDB0
        DEC     DE           ; 0303 1B
        JR      L031C        ; 0304 1816
        LD      DE,(S1FAF)   ; 0306 ED5BAF1F
        INC     DE           ; 030A 13
        INC     DE           ; 030B 13
        LD      HL,(M1FB1)   ; 030C 2AB11F
        OR      A            ; 030F B7
        SBC     HL,DE        ; 0310 ED52
        LD      A,L          ; 0312 7D
        RLA                  ; 0313 17
        LD      A,H          ; 0314 7C
        ADC     A,00H        ; 0315 CE00
        JR      NZ,ERROR     ; 0317 203A
        LD      A,L          ; 0319 7D
        DEC     DE           ; 031A 1B
        LD      (DE),A       ; 031B 12
L031C:
        LD      (M1FDE),DE   ; 031C ED53DE1F
        CALL    L040B        ; 0320 CD0B04
        RET                  ; 0323 C9
;----------------------------------------------------------
;------    
MWRIT:
        CALL    LENKS        ; 0324 CD2D05       KS!
        JR      C,ERROR      ; 0327 382A     -Err . .
L0329:
        LD      (M1FB5),A    ; 0329 32B51F  this is KS!  3
;------ KS -   -       
        LD      HL,(M1FB3)
        PUSH    HL
        CALL    LENBC
        LD      (M1FB3),BC
L0332:
        LD      HL,S1FAF     ; 0332 21AF1F               3  _start_end_KS 1FB5
        LD      BC,0007H     ; 0335 010700               3  +1 - 7 
        CALL    L056B        ; 0338 CDA705  L056B        3   : start HL,  BC .
        POP     HL
        LD      (M1FB3),HL
;------ LD      HL,0FA0H     ; 033B 21A00F               3     
L033E:
;------ CALL    TONE2        ; 033E CDE205 Mid Sync ?    3    
;        DJNZ    L033E        ; 033E 10xx                 2
;        NOP                  ; 0340 00                   1    3
L0341:
        CALL    LENBC        ; 0341 CD3A05 BC=Length+1   3    start HL,  BC
        CALL    L056B        ; 0344 CDA705  L056B        3    : start HL,  BC
L0347:
        JP      L034D        ; 02E1 C34D03               3  -
;------ LD      HL,0FA0H     ; 0347 21A00F               3  
;        CALL    TONE2        ; 034A CDE205 Tail Sync ?   3 
L034D:
        LD      DE,(M1FB3)   ; 034D ED5BB31F
        JR      L031C        ; 0351 18C9
ERROR:
        LD      IX,M07A9     ; 0353 DD21A907    -Err . .
        JP      L00D0        ; 0357 C3D000
;----------------------------------------------------------------------------------
;------    
;------    -    ,   RS-232
MREAD:
        LD      HL,(S1FAF)   ; 035A 2AAF1F -  ""  ()
        LD      (M1FEA),HL   ; 035D 22EA1F -   
CC360:
;        LD      A,40H        ; 0360 3E40  0100.0000 - 
;        OUT     (01H),A      ; 0362 D301     
;        LD      HL,1800H     ; 0376 21AF1F -    ()
;        LD      (M1FB1),HL   ; 035D 22EA1F
;        LD      HL,182FH     ; 0379 010700  -   
;        LD      (M1FB3),HL   ; 035D 22EA1F
;        LD      A,0E5H       ; 0360 3EE5
;        LD      (M1FB5),A    ; 003E 32B51F  -  .. 

;        LD      A,85H        ; 0397 3E85   "L" - 
;        OUT     (01H),A      ; 0399 D301      
        LD      A,0C0H        ; 0397 3E85   1100.0001
        OUT     (02H),A      ; 0399 D301       

        JP      MY376        ; 0357 C3D000  MY39B                                3
;        NOP                   ;                                                  1

        LD      HL,03E8H     ; 0364 21E803 = 1000d
CC367:
;        CALL    LNGDE        ; 0367 CD8C05   _/\_/  DE
;        JR      C,CC360      ; 036A 38F4     E  2AH (42)
;                               C (E-2AH) ,  E < 2AH
        DEC     HL           ; 036C 2B
        LD      A,H          ; 036D 7C
        OR      L            ; 036E B5
        JR      NZ,CC367     ; 036F 20F6
CC371:
        CALL    LNGDE        ; 0371 CD8C05   _/\_/  DE
        JR      NC,CC371     ; 0374 30FB
MY376:
        LD      HL,S1FAF     ; 0376 21AF1F  -   ""  ()
        LD      BC,0007H     ; 0379 010700  - 7 
        CALL    RBLOK        ; 037C CD4D05  -  ,  .   KS
        JR      C,CC360      ; 037F 38DF

        JP      MY39B        ; 0357 C3D000

;        LD      DE,(S1FAF)   ; 0381 ED5BAF1F
        CALL    HEXDE        ; 0385 CD6506
        NOP
;        LD      B,96H        ; 0388 0696     150d
CC38A:
        CALL    SCAN1        ; 038A CD2406
        DJNZ    CC38A        ; 038D 10FB

;        LD      HL,(M1FEA)   ; 038F 2AEA1F    () 
;        OR      A            ; 0392 B7
;        SBC     HL,DE        ; 0393 ED52
        JR      NZ,CC360     ; 0395 20C9      -  !

MY39B:
;        CALL    LENBC        ; 039B CD3A05
;        JR      C,ERROR      ; 039E 38B3
;        LD      BC,0030H     ; 035D 22EA1F -   BC
        LD      HL,(M1FB1)   ; 035A 2AAF1F -   
        LD      BC,(M1FB3)
;        NOP
MY3A0:
        CALL    RBLOK        ; 03A0 CD4D05
        JR      C,ERROR      ; 03A3 38AE
        LD      HL,(M1FB1)   ; 035A 2AAF1F -   
        LD      DE,(M1FB3)
        DEC     DE
        ADD     HL,DE
        LD      (M1FB3),HL
MY3A5:
        CALL    LENKS        ; 03A5 CD2D05
        LD      HL,M1FB5     ; 03A8 21B51F  KS
        CP      (HL)         ; 03AB BE      A<->(HL)
        JR      NZ,ERROR     ; 03AC 20A5

        JR      L034D        ; 03AE 189D

L03B0:
        LD      E,(HL)       ; 03B0 5E
        INC     HL           ; 03B1 23
        LD      D,(HL)       ; 03B2 56
        INC     HL           ; 03B3 23
        ADD     A,L          ; 03B4 85
        LD      L,A          ; 03B5 6F
        LD      L,(HL)       ; 03B6 6E
        LD      H,00H        ; 03B7 2600
        ADD     HL,DE        ; 03B9 19
        JP      (HL)         ; 03BA E9
L03BB:
        LD      HL,M1FE6     ; 03BB 21E61F
        SET     7,(HL)       ; 03BE CBFE
        RET                  ; 03C0 C9

L03C1:
        LD      IX,M07A5     ; 03C1 DD21A507 ***   ------
        LD      C,07H        ; 03C5 0E07
L03C7:
        LD      B,10H        ; 03C7 0610
L03C9:
        CALL    SCAN1        ; 03C9 CD2406
        DJNZ    L03C9        ; 03CC 10FB  B,10H
        DEC     IX           ; 03CE DD2B
        DEC     C            ; 03D0 0D
        JR      NZ,L03C7     ; 03D1 20F4
        LD      A,0A5H       ; 03D3 3EA5
        JP      L06B3        ; 03D5 C3B306
;------------------------------------------------------------------
L03D8:
        LD      HL,L0066     ; 03D8 216600 ---   NMI
        LD      (M1FEE),HL   ; 03DB 22EE1F       M1FEE
L03DE:
        LD      HL,0FFFFH    ; 03DE 21FFFF
        LD      (M1FE0),HL   ; 03E1 22E01F
        RET                  ; 03E4 C9

L03E5:
        LD      A,(M1FE4)    ; 03E5 3AE41F
        CP      01H          ; 03E8 FE01
        RET     Z            ; 03EA C8

        CP      02H          ; 03EB FE02
        RET                  ; 03ED C9

L03EE:
        LD      A,(M1FE6)    ; 03EE 3AE61F
        OR      A            ; 03F1 B7
        RET     Z            ; 03F2 C8

        LD      A,00H        ; 03F3 3E00
        LD      (HL),A       ; 03F5 77
        LD      (M1FE6),A    ; 03F6 32E61F
        RET                  ; 03F9 C9

L03FA:
        CALL    L03EE        ; 03FA CDEE03
        RET     Z            ; 03FD C8

        INC     HL           ; 03FE 23
        LD      (HL),A       ; 03FF 77
        DEC     HL           ; 0400 2B
        RET                  ; 0401 C9

L0402:
        LD      A,01H        ; 0402 3E01
        LD      B,04H        ; 0404 0604
        LD      HL,M1FB8     ; 0406 21B81F
        JR      L0412        ; 0409 1807
L040B:
        LD      A,02H        ; 040B 3E02
        LD      B,02H        ; 040D 0602
        LD      HL,M1FB6     ; 040F 21B61F
L0412:
        LD      (M1FE4),A    ; 0412 32E41F
        EXX                  ; 0415 D9
        LD      DE,(M1FDE)   ; 0416 ED5BDE1F
        CALL    HEXDE        ; 041A CD6506
        LD      A,(DE)       ; 041D 1A
        CALL    L0671        ; 041E CD7106
        LD      HL,(M1FE0)   ; 0421 2AE01F
        LD      A,(HL)       ; 0424 7E
        LD      (M1FE2),A    ; 0425 32E21F
        OR      A            ; 0428 B7
        SBC     HL,DE        ; 0429 ED52
        JR      NZ,L0433     ; 042B 2006
        LD      B,06H        ; 042D 0606
        LD      HL,M1FB6     ; 042F 21B61F
        EXX                  ; 0432 D9
L0433:
        EXX                  ; 0433 D9
L0434:
        SET     6,(HL)       ; 0434 CBF6
        INC     HL           ; 0436 23
        DJNZ    L0434        ; 0437 10FB
        RET                  ; 0439 C9

L043A:
        CALL    L0455        ; 043A CD5504
        LD      E,(HL)       ; 043D 5E
        INC     HL           ; 043E 23
        LD      D,(HL)       ; 043F 56
        CALL    HEXDE        ; 0440 CD6506
        LD      HL,M1FB8     ; 0443 21B81F
        LD      B,04H        ; 0446 0604
        CALL    L0434        ; 0448 CD3404
        CALL    L045F        ; 044B CD5F04
        LD      L,A          ; 044E 6F
        LD      H,02H        ; 044F 2602
        LD      (M1FB6),HL   ; 0451 22B61F
        RET                  ; 0454 C9

L0455:
        LD      A,(M1FE3)    ; 0455 3AE31F
        ADD     A,A          ; 0458 87
        LD      HL,S1FAF     ; 0459 21AF1F
        ADD     A,L          ; 045C 85
        LD      L,A          ; 045D 6F
        RET                  ; 045E C9

L045F:
        LD      A,(M1FE4)    ; 045F 3AE41F
        SUB     04H          ; 0462 D604
        ADD     A,A          ; 0464 87
        ADD     A,A          ; 0465 87
        LD      DE,M07BC     ; 0466 11BC07 ***
        ADD     A,E          ; 0469 83
        LD      E,A          ; 046A 5F
        LD      A,(M1FE3)    ; 046B 3AE31F
        ADD     A,E          ; 046E 83
        LD      E,A          ; 046F 5F
        LD      A,(DE)       ; 0470 1A
        OR      A            ; 0471 B7
        RET                  ; 0472 C9

L0473:
        LD      A,08H        ; 0473 3E08
        JR      L0479        ; 0475 1802
L0477:
        LD      A,09H        ; 0477 3E09
L0479:
        LD      (M1FE4),A    ; 0479 32E41F
        LD      A,(M1FE3)    ; 047C 3AE31F
        RES     0,A          ; 047F CB87
        LD      B,A          ; 0481 47
        CALL    L04AE        ; 0482 CDAE04
        LD      A,B          ; 0485 78
        CALL    L04BE        ; 0486 CDBE04
        LD      E,(HL)       ; 0489 5E
        INC     HL           ; 048A 23
        LD      D,(HL)       ; 048B 56
        LD      (M1FDE),DE   ; 048C ED53DE1F
        CALL    HEXDE        ; 0490 CD6506
        LD      A,(M1FE4)    ; 0493 3AE41F
        CP      09H          ; 0496 FE09
        RET     NZ           ; 0498 C0

        LD      HL,M1FB8     ; 0499 21B81F
        LD      A,(M1FE3)    ; 049C 3AE31F
        BIT     0,A          ; 049F CB47
        JR      Z,L04A5      ; 04A1 2802
        INC     HL           ; 04A3 23
        INC     HL           ; 04A4 23
L04A5:
        SET     6,(HL)       ; 04A5 CBF6
        INC     HL           ; 04A7 23
        SET     6,(HL)       ; 04A8 CBF6
        CALL    L04C4        ; 04AA CDC404
        RET                  ; 04AD C9

L04AE:
        LD      HL,M07D0     ; 04AE 21D007 ***
        ADD     A,L          ; 04B1 85
        LD      L,A          ; 04B2 6F
        LD      E,(HL)       ; 04B3 5E
        INC     HL           ; 04B4 23
        LD      D,(HL)       ; 04B5 56
        LD      (M1FB6),DE   ; 04B6 ED53B61F
        RET                  ; 04BA C9

L04BB:
        LD      A,(M1FE3)    ; 04BB 3AE31F
L04BE:
        LD      HL,M1FBC     ; 04BE 21BC1F
        ADD     A,L          ; 04C1 85
        LD      L,A          ; 04C2 6F
        RET                  ; 04C3 C9

L04C4:
        LD      A,(M1FE3)    ; 04C4 3AE31F
        OR      A            ; 04C7 B7
        RRA                  ; 04C8 1F
        CP      0BH          ; 04C9 FE0B
        JR      Z,L04D6      ; 04CB 2809
        LD      C,A          ; 04CD 4F
        LD      HL,M1FD2     ; 04CE 21D21F
        LD      A,(HL)       ; 04D1 7E
        AND     01H          ; 04D2 E601
        LD      (HL),A       ; 04D4 77
        LD      A,C          ; 04D5 79
L04D6:
        CP      0CH          ; 04D6 FE0C
        JR      NC,L04F9     ; 04D8 301F
        LD      A,(M1FBC)    ; 04DA 3ABC1F
        CALL    L0518        ; 04DD CD1805
        LD      (1FD4H),HL   ; 04E0 22D41F
        CALL    L0518        ; 04E3 CD1805
        LD      (1FD6H),HL   ; 04E6 22D61F
        LD      A,(1FC4H)    ; 04E9 3AC41F
        CALL    L0518        ; 04EC CD1805
        LD      (1FD8H),HL   ; 04EF 22D81F
        CALL    L0518        ; 04F2 CD1805
        LD      (1FDAH),HL   ; 04F5 22DA1F
        RET                  ; 04F8 C9

L04F9:
        LD      HL,(1FD4H)   ; 04F9 2AD41F
        CALL    L0523        ; 04FC CD2305
        LD      HL,(1FD6H)   ; 04FF 2AD61F
        CALL    L0523        ; 0502 CD2305
        LD      (M1FBC),A    ; 0505 32BC1F
        LD      HL,(1FD8H)   ; 0508 2AD81F
        CALL    L0523        ; 050B CD2305
        LD      HL,(1FDAH)   ; 050E 2ADA1F
        CALL    L0523        ; 0511 CD2305
        LD      (1FC4H),A    ; 0514 32C41F
        RET                  ; 0517 C9

L0518:
        LD      B,04H        ; 0518 0604
L051A:
        ADD     HL,HL        ; 051A 29 * 2
        ADD     HL,HL        ; 051B 29 * 4
        ADD     HL,HL        ; 051C 29 * 8
        RLCA                 ; 051D 07
        ADC     HL,HL        ; 051E ED6A
        DJNZ    L051A        ; 0520 10F8
        RET                  ; 0522 C9

L0523:
        LD      B,04H        ; 0523 0604
L0525:
        ADD     HL,HL        ; 0525 29 * 2
        ADD     HL,HL        ; 0526 29 * 4
        ADD     HL,HL        ; 0527 29 * 8
        ADD     HL,HL        ; 0528 29 * 16
        RLA                  ; 0529 17
        DJNZ    L0525        ; 052A 10F9
        RET                  ; 052C C9

;-----------------------------------------------------------------
;------     BC, Start - End; HL - Start
;------      - KS
LENKS:
        CALL    LENBC        ; 052D CD3A05
        RET     C            ; 0530 D8
L0531:
        XOR     A            ; 0531 AF    A = 0
L0532:
        ADD     A,(HL)       ; 0532 86
        CPI                  ; 0533 EDA1  A - (HL)
        JP      PE,L0532     ; 0535 EA3205
        OR      A            ; 0538 B7
        RET                  ; 0539 C9

;------------------------------------------------------
;------     BC, Start - End
;------  : HL - Start
;                                        S1FAF  Name
;                                        M1FB0
;                                        M1FB1  Start
;                                        M1FB2
;                                        M1FB3  End
;                                        M1FB4
;                                        M1FB5  KS
LENBC:
        LD      HL,M1FB1     ; 053A 21B11F
L053D:
        LD      E,(HL)       ; 053D 5E - M1FB1 = E
        INC     HL           ; 053E 23   M1FB2
        LD      D,(HL)       ; 053F 56 - M1FB2 = D
        INC     HL           ; 0540 23
        LD      C,(HL)       ; 0541 4E - M1FB3 = C
        INC     HL           ; 0542 23   M1FB4
        LD      H,(HL)       ; 0543 66 - M1FB4 = H
        LD      L,C          ; 0544 69       L = C
        OR      A            ; 0545 B7      fC = 0
        SBC     HL,DE        ; 0546 ED52 HL = HL-DE
        LD      C,L          ; 0548 4D
        LD      B,H          ; 0549 44   BC = HL
        INC     BC           ; 054A 03   BC = BC + 1
        EX      DE,HL        ; 054B EB   HL<->DE
        RET                  ; 054C C9

;------------------------------------------------------
;------    HL - Start,   BC,
;------
RBLOK:
        XOR     A            ; 054D AF   A = 00
        EX      AF,AF'       ; 054E 08
L054F:
        CALL    RBYTE        ; 054F CD5A05
        LD      (HL),A       ; 0552 73

        CPI                  ; 0553 EDA1
        JP      PE,L054F     ; 0555 EA4F05
        EX      AF,AF'       ; 0558 08
        RET                  ; 0559 C9

;------------------------------------------
;------  
RBYTE:
        EXX
        LD      DE,0800H     ; 055A 1608   8                      3
        LD      BC,100CH     ; 0335 010700      3
CWAIT0:
        IN      A,(00H)      ; 058F DB00  read Port A (Wait "0")     2
        RLA                  ; 0592 17    Port A BIT7 -> C           1
        JR      C,CWAIT0     ; 0593 38FA  IF C=1 GOTO C0WAIT (CYCLE) 2
PAUSES:
        DJNZ    PAUSES       ; 05CD 10FE                             2
GETBIT:
        IN      A,(00H)      ; 058F DB00  read Port A (Wait "0")     2
        RLA                  ; 0592 17    Port A BIT7 -> C           1
        RR      E            ; 0562 CB1B                             2
        LD      B,C          ; 05EC 41                               1
        DEC     D            ; 0564 15                               1
        JR      NZ,PAUSES    ; 0565 20F8                             2
        LD      A,E          ; 05A3 7B
        EXX
        RET                  ; 056A C9

;------------------------------------------
;------   :  
L056B:
;        EXX                  ; 056B D9                  1
;        LD      HL,0000H     ; 056C 210000              3
        LD      A,0C0H       ; 0397 3E85   1100.0000 -  
        OUT     (02H),A      ; 0399 D301       
        OUT     (02H),A      ; 0399 D301       
;        LD      A,00H       ; 0397 3E85   1100.0000 -  
        JP      BLOCK        ; 05AD C3A705 HL = HL+1; BC=BC-1 -> PE/V
CC56F:
        CALL    LNGDE        ; 056F CD8C05              3
;        INC     D            ; 0572 14                  1
;        DEC     D            ; 0573 15                  1
;        JR      NZ,L0587     ; 0574 2011                2
;        JR      C,L057E      ; 0576 3806                2
;        DEC     L            ; 0578 2D                  1
;        DEC     L            ; 0579 2D                  1
;        SET     0,H          ; 057A CBC4                2
;        JR      CC56F        ; 057C 18F1                2
L057E:
;        INC     L            ; 057E 2C                  1
        BIT     0,H          ; 057F CB44                2
        JR      Z,CC56F      ; 0581 28EC                2
        RL      L            ; 0583 CB15                2
;        EXX                  ; 0585 D9                  1
        RET                  ; 0586 C9

L0587:
        EX      AF,AF'       ; 0587 08
        SCF                  ; 0588 37
        EX      AF,AF'       ; 0589 08
        EXX                  ; 058A D9
        RET                  ; 058B C9

;---------------------------------------------------------------------
;    : /\_/
;   9600  :  8...9,  8
;   4800  : 13...14,  14 (19...20)
;     ,  .
LNGDE:
        LD      DE,0000H     ; 058C 110000
CC58F:
        IN      A,(00H)      ; 058F DB00  read Port A (Wait "0")
        INC     DE           ; 0591 13    DE = DE+1
        RLA                  ; 0592 17    Port A BIT7 -> C
        JR      C,CC58F      ; 0593 38FA  IF C=1 GOTO CC58F (CYCLE)
        LD      A,0FFH       ; 0595 3EFF  1111.1111b
        OUT     (02H),A      ; 0597    "1" -> Port C BIT7
CC599:
        IN      A,(00H)      ; 0599 DB00  read Port  A (Wait "1")
        INC     DE           ; 059B 13    DE = DE+1
        RLA                  ; 059C 17    Port A BIT7 -> C
        JR      NC,CC599     ; 059D 30FA  IF C=0 GOTO CC599 (CYCLE)
        LD      A,7FH        ; 059F 3E7F  0111.1111b
        OUT     (02H),A      ; 05A1 D302  "0" -> Port C BIT7
        LD      A,E          ; 05A3 7B
        CP      2AH          ; 05A4 FE2A
        RET                  ; 05A6 C9

;---------------------------------------------------------------------
;------   : HL - , BC - 
BLOCK:
        LD      E,(HL)       ; 05A7 5E
        CALL    SBYTE        ; 05A8 CDB105
        CPI                  ; 05AB EDA1   : A - [HL] -> Z
        JP      PE,BLOCK     ; 05AD EAA705 HL = HL+1; BC=BC-1 -> PE/V
        RET                  ; 05B0 C9
;----------------------------------------------------------------------
;------    RS-233 : 8-N-1 ----------------
SBYTE:
        LD      D,08H        ; 05B1 1608
        OR      A            ; 05B3 B7     C=0
        CALL    SRBIT        ; 05B4 CDC405   C=0
CC5B7:
        RR      E            ; 05B7 CB1B   Rotat Right E = C->E
        CALL    SRBIT        ; 05B9 CDC405 = test current bit in fC
        DEC     D            ; 05BC 15     bit count
        JR      NZ,CC5B7     ; 05BD 20F8
        SCF                  ; 05BF 37     C=1
        CALL    SRBIT        ; 05C0 CDC405   C=1
        RET                  ; 05C3 C9

;       06E1 -  0736
;----------------------------------------------------------------------
;------     RS-233: -------------------------------
SRBIT:
        EXX                  ; 05C4 D9                     1
        JR      C,L05D4      ; 05C5 3809      fC = 1                  2
        LD      A,40H        ; 05C7 3EFF    1011.1111 0BFH                      2
        OUT     (03H),A      ; 05C9 D302    OUT     (02H),A                     2
        LD      B,08H        ; 05CB 2607                  2
L05CD:
        DJNZ    L05CD        ; 05CD 10FE
        EXX                  ; 05CF D9                1
        RET                  ; 05D0 C9                                          1
        NOP                  ; 05D1 00                                          1
        NOP                  ; 05D2 00                                          1
        NOP                  ; 05D3 00                                          1
L05D4:
        LD      A,0C0H       ; 05D4 3EFF    1111.1111 0FFH                      2
        OUT     (03H),A      ; 05D6 D302   OUT     (02H),A                      2
        LD      B,08H        ; 05D8 2607                  2
L05DA:
        DJNZ    L05DA        ; 05DA 10FE                                        2
        EXX                  ; 05DC D9                1
        RET                  ; 05DD C9                                          1

;TONE1K  Generate sound at 1 kHz.
TONE1:
        LD      C,41H        ; 05DE 0E41
        JR      TONEG        ; 05E0 1802

;TONE2K  Generate sound at 2 kHz.
TONE2:
        LD      C,1FH        ; 05E2 0E1F

;TONE   Generate sound. HL contains the number of cycles.
TONEG:
        ADD     HL,HL        ; 05E4 29     HL contains the number of cycles.
        LD      DE,0001H     ; 05E5 110100 Maximum value is 34768 =
        LD      A,0FFH       ; 05E8 3EFF   65536 / 2 ->(ADD HL,HL !)
L05EA:
        OUT     (02H),A      ; 05EA D302
        LD      B,C          ; 05EC 41
L05ED:
        DJNZ    L05ED        ; 05ED 10FE
        XOR     80H          ; 05EF EE80
        SBC     HL,DE        ; 05F1 ED52
        JR      NZ,L05EA     ; 05F3 20F5
        RET                  ; 05F5 C9

;RAMCHK Check if the given address is RAM.
RAMCH:
        LD      A,(HL)       ; 05F6 7E
        CPL                  ; 05F7 2F
        LD      (HL),A       ; 05F8 77
        LD      A,(HL)       ; 05F9 7E
        CPL                  ; 05FA 2F
        LD      (HL),A       ; 05FB 77
        CP      (HL)         ; 05FC BE
        RET                  ; 05FD C9

;SCANP  Scan keyboard and display until a new key-in.
SCANP:
        PUSH    IX           ; 05FE DDE5
        LD      HL,M1FE6     ; 0600 21E61F
        BIT     7,(HL)       ; 0603 CB7E
        JR      Z,L060B      ; 0605 2804
        LD      IX,M07A5     ; 0607 DD21A507  *** ------
L060B:
        LD      B,04H        ; 060B 0604
L060D:
        CALL    SCAN1        ; 060D CD2406
        JR      NC,L060B     ; 0610 30F9
        DJNZ    L060D        ; 0612 10F9
        RES     7,(HL)       ; 0614 CBBE
        POP     IX           ; 0616 DDE1
L0618:
        CALL    SCAN1        ; 0618 CD2406
        JR      C,L0618      ; 061B 38FB
        LD      HL,M077B     ; 061D 217B07  ***
        ADD     A,L          ; 0620 85
        LD      L,A          ; 0621 6F
        LD      A,(HL)       ; 0622 7E
        RET                  ; 0623 C9

;SCAN1  Scan keyboard and display one cycle.
SCAN1:
        SCF                  ; 0624 37
        EX      AF,AF'       ; 0625 08
        EXX                  ; 0626 D9
        LD      C,00H        ; 0627 0E00
        LD      E,0C1H       ; 0629 1EC1
        LD      H,06H        ; 062B 2606
L062D:
        LD      A,E          ; 062D 7B
        OUT     (02H),A      ; 062E D302
        LD      A,(IX+00H)   ; 0630 DD7E00
        OUT     (01H),A      ; 0633 D301
        LD      B,0C9H       ; 0635 06C9
L0637:
        DJNZ    L0637        ; 0637 10FE
        XOR     A            ; 0639 AF
        OUT     (01H),A      ; 063A D301
        LD      A,E          ; 063C 7B
        CPL                  ; 063D 2F
        OR      0C0H         ; 063E F6C0
        OUT     (02H),A      ; 0640 D302
        LD      B,06H        ; 0642 0606
        IN      A,(00H)      ; 0644 DB00
        LD      D,A          ; 0646 57
L0647:
        RR      D            ; 0647 CB1A
        JR      C,L064D      ; 0649 3802
        LD      A,C          ; 064B 79
        EX      AF,AF'       ; 064C 08
L064D:
        INC     C            ; 064D 0C
        DJNZ    L0647        ; 064E 10F7
        INC     IX           ; 0650 DD23
        LD      A,E          ; 0652 7B
        AND     3FH          ; 0653 E63F  0011.1111b
        RLC     A            ; 0655 CB07
        OR      0C0H         ; 0657 F6C0
        LD      E,A          ; 0659 5F
        DEC     H            ; 065A 25
        JR      NZ,L062D     ; 065B 20D0
        LD      DE,0FFFAH    ; 065D 11FAFF ???
        ADD     IX,DE        ; 0660 DD19
        EXX                  ; 0662 D9
        EX      AF,AF'       ; 0663 08
        RET                  ; 0664 C9

HEXDE:
        LD      HL,M1FB8     ; 0665 21B81F
        LD      A,E          ; 0668 7B
        CALL    HEX7S        ; 0669 CD7806
        LD      A,D          ; 066C 7A
        CALL    HEX7S        ; 066D CD7806
        RET                  ; 0670 C9

L0671:
        LD      HL,M1FB6     ; 0671 21B61F
        CALL    HEX7S        ; 0674 CD7806
        RET                  ; 0677 C9

;HEX7SG  Convert two hexadecimal digits to 7 segment format.
HEX7S:
        PUSH    AF           ; 0678 F5
        CALL    HEX71        ; 0679 CD8906
        LD      (HL),A       ; 067C 77
        INC     HL           ; 067D 23
        POP     AF           ; 067E F1
        RRCA                 ; 067F 0F
        RRCA                 ; 0680 0F
        RRCA                 ; 0681 0F
        RRCA                 ; 0682 0F
        CALL    HEX71        ; 0683 CD8906
        LD      (HL),A       ; 0686 77
        INC     HL           ; 0687 23
        RET                  ; 0688 C9

;HEX7  Convert a hexadecimal digit to 7 segment format.
HEX71:
        PUSH    HL           ; 0689 E5
        LD      HL,M07F0     ; 068A 21F007 ***
        AND     0FH          ; 068D E60F
        ADD     A,L          ; 068F 85
        LD      L,A          ; 0690 6F
        LD      A,(HL)       ; 0691 7E
        POP     HL           ; 0692 E1
        RET                  ; 0693 C9

        LD      HL,M1800     ; 0694 210018 RAM Begin
        LD      BC,0800H     ; 0697 010008 Length
L069A:
        CALL    RAMCH        ; 069A CDF605
        JR      Z,L06A0      ; 069D 2801
        HALT                 ; 069F 76

L06A0:
        CPI                  ; 06A0 EDA1
        JP      PE,L069A     ; 06A2 EA9A06
        RST     00H          ; 06A5 C7

        LD      HL,0000H     ; 06A6 210000
        LD      BC,0800H     ; 06A9 010008
        CALL    L0531        ; 06AC CD3105
        JR      Z,L06B2      ; 06AF 2801
        HALT                 ; 06B1 76

L06B2:
        RST     00H          ; 06B2 C7
L06B3:
        LD      (M1FE5),A    ; 06B3 32E51F
        LD      A,55H        ; 06B6 3E55
        LD      (M1FF0),A    ; 06B8 32F01F
        LD      A,44H        ; 06BB 3E44
        LD      (M1FF1),A    ; 06BD 32F11F
        LD      HL,M1FF2     ; 06C0 21F21F
        LD      (HL),2FH     ; 06C3 362F
        INC     HL           ; 06C5 23
        LD      (HL),00H     ; 06C6 3600
        JP      L03D8        ; 06C8 C3D803

;-------    ----
L06CB:
        PUSH    AF           ; 06CB F5
        LD      HL,M1FF1     ; 06CC 21F11F
        LD      C,(HL)       ; 06CF 4E
        LD      HL,(M1FF2)   ; 06D0 2AF21F
        LD      A,(M1FF0)    ; 06D3 3AF01F
        CP      55H          ; 06D6 FE55
        JR      NZ,L06DD     ; 06D8 2003
        CALL    TONEG        ; 06DA CDE405
L06DD:
        POP     AF           ; 06DD F1
        JP      L00E9        ; 06DE C3E900

;------ 06E1 -  0736 ------------------
L06E1:
        RST     38H          ; 06E1 FF
        DB      55H          ; 06E2 FF
        DB      55H          ; 06E3 FF
        DB      55H          ; 06E4 FF
        DB      55H          ; 06E5 FF
        DB      55H          ; 06E6 FF
        DB      55H          ; 06E7 FF
        DB      55H          ; 06E8 FF
        DB      55H          ; 06E9 FF
        DB      55H          ; 06EA FF
        DB      55H          ; 06EB FF
        DB      55H          ; 06EC FF
        DB      55H          ; 06ED FF
        DB      55H          ; 06EE FF
        DB      55H          ; 06EF FF
        DB      55H          ; 06F0 FF
        DB      55H          ; 06F1 FF
        DB      55H          ; 06F2 FF
        DB      55H          ; 06F3 FF
        DB      55H          ; 06F4 FF
        DB      55H          ; 06F5 FF
        DB      55H          ; 06F6 FF
        DB      55H          ; 06F7 FF
        DB      55H          ; 06F8 FF
        DB      55H          ; 06F9 FF
        DB      55H          ; 06FA FF
        DB      55H          ; 06FB FF
        DB      55H          ; 06FC FF
        DB      55H          ; 06FD FF
        DB      55H          ; 06FE FF
        DB      55H          ; 06FF FF
        DB      55H          ; 0700 FF
        DB      55H          ; 0701 FF
        DB      55H          ; 0702 FF
        DB      55H          ; 0703 FF
        DB      55H          ; 0704 FF
        DB      55H          ; 0705 FF
        DB      55H          ; 0706 FF
        DB      55H          ; 0707 FF
        DB      55H          ; 0708 FF
        DB      55H          ; 0709 FF
        DB      55H          ; 070A FF
        DB      55H          ; 070B FF
        DB      55H          ; 070C FF
        DB      55H          ; 070D FF
        DB      55H          ; 070E FF
        DB      55H          ; 070F FF
        DB      55H          ; 0710 FF
        DB      55H          ; 0711 FF
        DB      55H          ; 0712 FF
        DB      55H          ; 0713 FF
        DB      55H          ; 0714 FF
        DB      55H          ; 0715 FF
        DB      55H          ; 0716 FF
        DB      55H          ; 0717 FF
        DB      55H          ; 0718 FF
        DB      55H          ; 0719 FF
        DB      55H          ; 071A FF
        DB      55H          ; 071B FF
        DB      55H          ; 071C FF
        DB      55H          ; 071D FF
        DB      55H          ; 071E FF
        DB      55H          ; 071F FF
        DB      55H          ; 0720 FF
        DB      55H          ; 0721 FF
        DB      55H          ; 0722 FF
        DB      55H          ; 0723 FF
        DB      55H          ; 0724 FF
        DB      55H          ; 0725 FF
        DB      55H          ; 0726 FF
        DB      55H          ; 0727 FF
        DB      55H          ; 0728 FF
        DB      55H          ; 0729 FF
        DB      55H          ; 072A FF
        DB      55H          ; 072B FF
        DB      55H          ; 072C FF
        DB      55H          ; 072D FF
        DB      55H          ; 072E FF
        DB      55H          ; 072F FF
        DB      55H          ; 0730 FF
        DB      55H          ; 0731 FF
        DB      55H          ; 0732 FF
        DB      55H          ; 0733 FF
        DB      55H          ; 0734 FF
        DB      55H          ; 0735 FF
        DB      55H          ; 0736 FF
M0737:
        DEC     DE           ; 0737 1B     --!-- (10)
        LD      BC,0500H     ; 0738 010005
        LD      A,(BC)       ; 073B 0A
        RRCA                 ; 073C 0F
        LD      A,(DE)       ; 073D 1A
        INC     L            ; 073E 2C
        LD      B,D          ; 073F 42
        LD      A,E          ; 0740 7B
M0741:
        JP      NZ,0001H     ; 0741 C20100 --!-- (10)
        INC     E            ; 0744 1C
        LD      A,(BC)       ; 0745 0A
        INC     D            ; 0746 14
        JR      NZ,L0769     ; 0747 2020
        LD      H,26H        ; 0749 2626
M074B:
        CALL    PE,0001H     ; 074B EC0100 --!-- (12)
        LD      D,03H        ; 074E 1603
        LD      H,34H        ; 0750 2634
        INC     (HL)         ; 0752 34
        INC     (HL)         ; 0753 34
        INC     (HL)         ; 0754 34
        LD      H,44H        ; 0755 2644
M0757:
        DEC     A            ; 0757 3D --!-- (12)
        LD      (BC),A       ; 0758 02
        NOP                  ; 0759 00
        INC     BC           ; 075A 03
        INC     BC           ; 075B 03
        NOP                  ; 075C 00
        LD      C,0EH        ; 075D 0E0E
        LD      C,0EH        ; 075F 0E0E
        RRA                  ; 0761 1F
        RRA                  ; 0762 1F
M0763:
        LD      L,E          ; 0763 6B --!-- (12)
        LD      (BC),A       ; 0764 02
        NOP                  ; 0765 00
        INC     BC           ; 0766 03
        INC     BC           ; 0767 03
        NOP                  ; 0768 00
L0769:
        LD      C,0EH        ; 0769 0E0E
        LD      C,0EH        ; 076B 0E0E
        RRA                  ; 076D 1F
        RRA                  ; 076E 1F
M076F:
        SBC     A,C          ; 076F 99 --!--
        LD      (BC),A       ; 0770 02
        NOP                  ; 0771 00
        INC     BC           ; 0772 03
        INC     BC           ; 0773 03
        NOP                  ; 0774 00
        LD      C,E          ; 0775 4B
        LD      L,L          ; 0776 6D
        ADC     A,E          ; 0777 8B
        POP     BC           ; 0778 C1
        NOP                  ; 0779 00
        NOP                  ; 077A 00
M077B:
        INC     BC           ; 077B 03
        RLCA                 ; 077C 07
        DEC     BC           ; 077D 0B
        RRCA                 ; 077E 0F
        JR      NZ,L07A2     ; 077F 2021
        LD      (BC),A       ; 0781 02
        LD      B,0AH        ; 0782 060A
        LD      C,22H        ; 0784 0E22
        INC     HL           ; 0786 23
        LD      BC,0905H     ; 0787 010509
        DEC     C            ; 078A 0D
        INC     DE           ; 078B 13
        RRA                  ; 078C 1F
        NOP                  ; 078D 00
L078E:
        INC     B            ; 078E 04
        EX      AF,AF'       ; 078F 08
        INC     C            ; 0790 0C
        LD      (DE),A       ; 0791 12
        LD      E,1AH        ; 0792 1E1A
        JR      L07B1        ; 0794 181B
        ADD     HL,DE        ; 0796 19
        RLA                  ; 0797 17
        DEC     E            ; 0798 1D
L0799:
        DEC     D            ; 0799 15
        LD      DE,1014H     ; 079A 111410
        LD      D,1CH        ; 079D 161C
M079F:
        DB      30H          ; 079F 30   1
        DB      02H          ; 07A0 02   -
        DB      02H          ; 07A1 02   -
L07A2:
        DB      0FH          ; 07A2 0F   F
        DB      1FH          ; 07A3 1F   P
        DB     0A1H          ; 07A4 A1   u
M07A5:
        DB      00H          ; 07A5 00 ' '
        DB      00H          ; 07A6 00 ' '
        DB      00H          ; 07A7 00 ' '
        DB      00H          ; 07A8 00 ' '
M07A9:
        DB      00H          ; 07A9 00 ' '    -Err . .
        DB      00H          ; 07AA 00 ' '

        DB      03H          ; 07AB 03  r
        DB      03H          ; 07AC 03  r
        DB      8FH          ; 07AD 8F  E
        DB      02H          ; 07AE 02  -
M07AF:
        DB      1FH          ; 07AF 1F  P
        DB     0AEH          ; 07B0 AE  S
L07B1:
        DB      02H          ; 07B1 02  -
        DB     0AEH          ; 07B2 AE  S
        DB     0B6H          ; 07B3 B6  Y
        DB     0AEH          ; 07B4 AE  S
M07B5:
        DB      1FH          ; 07B5 1F  P
        DB     0AEH          ; 07B6 AE  S or 5
        DB      02H          ; 07B7 02  -
        DB      03H          ; 07B8 03  r
        DB      03H          ; 07B9 03  r
        DB      8FH          ; 07BA 8F  E
        DB      00H          ; 07BB 00 ' '
M07BC:
        DB     0AEH          ; 07BC AE  S or 5
        DB      8FH          ; 07BD 8F  E
        DB     0B3H          ; 07BE B3  d
        DB      00H          ; 07BF 00 ' '
        DB     0AEH          ; 07C0 AE  S or 5
        DB     0B3H          ; 07C1 B3  d
        DB      00H          ; 07C2 00 ' '
        DB      00H          ; 07C3 00 ' '
        DB      0FH          ; 07C4 0F  F
        DB     0AEH          ; 07C5 AE  S or 5
        DB      8FH          ; 07C6 8F  E
        DB      00H          ; 07C7 00 ' '
        DB      0FH          ; 07C8 0F  F
        DB      00H          ; 07C9 00 ' '
M07CA:
        DB      00H          ; 07CA 00 ' '
        DB      00H          ; 07CB 00 ' '
        DB      02H          ; 07CC 02  -
        DB     0BEH          ; 07CD BE  9
        DB      8FH          ; 07CE 8F  E
        DB      03H          ; 07CF 03  r
M07D0:
        DB      0FH          ; 07D0 0F  F
        DB      3FH          ; 07D1 3F  A
        DB      8DH          ; 07D2 8D  C
        DB     0A7H          ; 07D3 A7  b
        DB      8FH          ; 07D4 8F  E
        DB     0B3H          ; 07D5 B3  d
        DB      85H          ; 07D6 85  L
        DB      37H          ; 07D7 37  H
        DB      4FH          ; 07D8 4F  F.
        DB      3FH          ; 07D9 3F  A
        DB     0CDH          ; 07DA CD  C.
        DB     0A7H          ; 07DB A7  b
        DB     0CFH          ; 07DC CF  E.
        DB     0B3H          ; 07DD B3  d
        DB     0C5H          ; 07DE C5  L.
        DB      37H          ; 07DF 37  H
        DB      07H          ; 07E0 07  |-
        DB      30H          ; 07E1 30  1
        DB     0B6H          ; 07E2 B6  Y
        DB      30H          ; 07E3 30  1
        DB      1FH          ; 07E4 1F  P
        DB     0AEH          ; 07E5 AE  5
        DB      0FH          ; 07E6 0F  F
        DB      30H          ; 07E7 30  1
        DB      37H          ; 07E7 37  H
        DB      0FH          ; 07E9 0F  F
        DB      85H          ; 07EA 85  L
        DB      0FH          ; 07EB 0F  F
        DB      77H          ; 07EC 77  H.
        DB      0FH          ; 07ED 0F  F
        DB     0C5H          ; 07EE C5  L.
        DB      0FH          ; 07EF 0F  F
M07F0:
        DB     0BDH          ; 07F0 BD  0
        DB      30H          ; 07F1 30  1
        DB      9BH          ; 07F2 9B  2
        DB     0BAH          ; 07F3 BA  3
        DB      36H          ; 07F4 36  4
        DB     0AEH          ; 07F5 AE  5
        DB     0AFH          ; 07F6 AF  6
        DB      38H          ; 07F7 38  7
        DB     0BFH          ; 07F8 BF  8
        DB     0BEH          ; 07F9 BE  9
        DB      3FH          ; 07FA 3F  A
        DB     0A7H          ; 07FB A7  b
        DB      8DH          ; 07FC 8D  C
        DB     0B3H          ; 07FD B3  d
        DB      8FH          ; 07FE 8F  E
        DB      0FH          ; 07FF 0F  F

M1800   EQU     1800H        ; 1800H - 1D00H  User program and data memory.
M1DFE   EQU     1DFEH
M1E00   EQU     1E00H
M1F9F   EQU     1F9FH
M1FB1   EQU     1FB1H
M1FB3   EQU     1FB3H
M1FB5   EQU     1FB5H
M1FB6   EQU     1FB6H
M1FB8   EQU     1FB8H
M1FBC   EQU     1FBCH
M1FBD   EQU     1FBDH
M1FD0   EQU     1FD0H
M1FD2   EQU     1FD2H
M1FD3   EQU     1FD3H
M1FDC   EQU     1FDCH
M1FDE   EQU     1FDEH
M1FE0   EQU     1FE0H
M1FE2   EQU     1FE2H
M1FE3   EQU     1FE3H
M1FE4   EQU     1FE4H
M1FE5   EQU     1FE5H       ; warm reset (value A5H) and a cold reset
M1FE6   EQU     1FE6H
M1FE7   EQU     1FE7H
M1FE8   EQU     1FE8H
M1FEA   EQU     1FEAH
M1FEB   EQU     1FEBH
M1FEE   EQU     1FEEH
M1FF0   EQU     1FF0H       ; Key presses beep only if this value is 55H

M1FF1   EQU     1FF1H       ; C,(HL)
M1FF2   EQU     1FF2H       ; HL
M1FF3   EQU     1FF3H       ; --

S1FAF   EQU     1FAFH       ; SP
        END